/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de
  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <math.h>
#include <stdlib.h>
#include "getcircle.h"

#include <kmessagebox.h>


GetCircle::GetCircle()
	{
	}

GetCircle::~GetCircle()
	{
	}
/*
long int GetCircle::get_sector( long int r, long int start_x, char sector, )
	{
	long int Y, X;
	div_t neu;

	X = 0;
	Y = r;
	while ( X != x )
		{
		X ++;
		neu = div(( r * r - X * X ), Y );
		if ( neu.rem * 2 >= Y )
			neu.quot  ++;
		if ( neu.quot < Y )
			Y --;
		}
	return Y;
	}*/

long int GetCircle::get_r2y( long int r, long int x )
	{
	long int Y, X;
	div_t neu;

	X = 0;
	Y = r;
	while ( X != x )
		{
		X ++;
		neu = div(( r * r - X * X ), Y );
		if ( neu.rem * 2 >= Y )
			neu.quot  ++;
		if ( neu.quot < Y )
			Y --;
		}
	return Y;
	}

long int GetCircle::get_l2y( long int r, long int x, long int sx, long int sy )
	{
	long int Y, X;
	div_t neu;

	X = sx;
	Y = sy;
	while ( X != x )
		{
		X --;
		neu = div(( r * r - X * X ), Y );
		if ( neu.rem * 2 >= Y )
			neu.quot  ++;
		if ( neu.quot > Y )
			Y ++;
		}
	return Y;
	}

long int GetCircle::get_l1x( long int r, long int y )
	{
	long int Y, X;
	div_t neu;

	X = r;
	Y = 0;
	while ( Y != y )
		{
		Y ++;
		neu = div(( r * r - Y * Y ), X );
		if ( neu.rem * 2 >= X )
			neu.quot  ++;
		if ( neu.quot < X )
			X --;
		}
	return X;
	}

long int GetCircle::get_r1x( long int r, long int y, long int sx, long int sy )
	{
	long int Y, X;
	div_t neu;

	X = sy;
	Y = sx;
	while ( Y != y )
		{
		Y --;
		neu = div(( r * r - Y * Y ), X );
		if ( neu.rem * 2 >= X )
			neu.quot  ++;
		if ( neu.quot > X )
			X ++;
		}
	return X;
	}

/**
 * Returns the complete string of a circle and calculates every thing.
 * @param mf		machine factor
 * @param r			radius
 * @param kdev		cercle devinition, gets extended by this function, only thing it must contain is direction and axis
 * @param pr 		precision
 * @param s1		start sector
 * @param x1		start X,  the smaler value of X, Y will be used
 * @param y1		start Y
 * @param s2		end sector
 * @param x2		end X
 * @param y2		end Y
 * @return 			the KREIS string for insertion.
 */
QString GetCircle::getCircle( uint mf, double r, char *kdev, double pr, char s1, double x1, double y1, char s2, double x2, double y2 )
	{
	long int steps, R2, R, X, Y, X2, Y2;
	double dx = 0, dy = 0;
	QString li;
	div_t d;

	R = long( r * mf * 100.00 );
	R2 = R * R;

	if ( kdev[5] == '0' )  // left around
		{
		if ( x1 < y1 )
			{
			X = long( x1 * mf * 100.00 );
			long Y2 = R2 - X * X ;
			Y = Y2;
			do
				{
				d = div( Y, 2 );
				Y = d.quot;
				}
			while ( d.quot * d.quot > Y2 );

			if ( d.rem )
				Y++;
			}
		else
			{
			Y = long( y1 * mf * 100.00 );
			X = R2 - Y * Y ;
			}
		switch ( s1 )
			{
			case 1:
				{
				while ( X <= Y )
					{
					X ++;
					d = div(( r * r - X * X ), Y );
					if ( d.rem * 2 >= Y )
						d.quot  ++;
					if ( d.quot < Y )
						Y --;
					}
				}
			case 2:
				{
				}
			}
		}
	else
		{
		}


	}


/**
 *
 * @param mf
 * @param r
 * @param kdev
 * @param pr
 * @param s1
 * @param x1
 * @param y1
 * @param s2
 * @param x2
 * @param y2
 * @param cd		circle data, contains on return calculated values of the circle.
 * @return
 */
QString GetCircle::getCircle( uint mf, double r, char *kdev, double pr, char s1, double x1, double y1, char s2, double x2, double y2, CircleData *cd )
	{
	long int sx, sy, r2, s = 0, X1, Y1, X2, Y2;
	double dx = 0, dy = 0;
	QString li;
	div_t xn;

	sy = 0;
	sx = long( r * mf * 100.00 );
	//KMessageBox::Information( 0, QString("sx =  %1\nr =  %2").arg(sx).arg(r), "Info");
	r2 = sx * sx;

	while ( sy < sx )   // Checks where the change is: sx holds steps of X; sy holds steps of Y
		{
		sy ++;
		xn = div(( r2 - sy * sy ), sx );
		if ( xn.rem * 2 >= sx )
			xn.quot  ++;
		if ( sx > xn.quot )
			sx --;
		}

	X1 = long( round( x1 * mf * 100.00 ) );
	Y1 = long( round( y1 * mf * 100.00 ) );
	X2 = long( round( x2 * mf * 100.00 ) );
	Y2 = long( round( y2 * mf * 100.00 ) );

	if ( kdev[5] == '0' )  // left around
		switch ( s1 )
			{
			case 1:
				if ( x1 > y1 )
					{
					// sec1
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '0';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if ( y1 >= y2 )
									{
									// from sec1 to sec1
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{
									// from sec1 to sec1
									s = Y2 - Y1;
									}
								}
							else
								{
								// from sec1 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x2 - x1;
							dy = y2 - y1;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec1 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + X2;
								}
							else
								{
								// from sec1 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y2 - y1;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec1 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{
								// from sec1 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s =  sy - Y1 + 2 * sx + 2 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = - ( y1 + y2 );
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec1 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec1 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + abs( sy - Y2 );
								}
							dx = x2 - x1;
							dy = - ( y1 + y2 );
							break;
						}
					}
				else
					{
					// sec2
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '0';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec2 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 3 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if ( x1 <= x2 )
									{
									// from sec2 to sec2
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{
									// from sec2 to sec2   y2 > y1
									s = X1 - X2;
									}
								}
							dx = x2 - x1;
							dy = y2 - y1;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec2 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{
								// from sec2 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y2 - y1;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec2 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{
								// from sec2 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = - ( y1 + y2 );
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec2 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec2 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x2 - x1;
							dy = - ( y1 + y2 );
							break;
						}
					}
				break;

			case 2:
				if ( x1 < y1 )
					{
					// sec3
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '1';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec3 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}

							else
								{
								// from sec3 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  x1 + x2;
							dy = y2 - y1;
							break;

						case 2:
							if ( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if ( x1 >= x2 )
									{
									// from sec3 to sec3
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{
									// from sec3 to sec3
									s = X2 - X1;
									}
								}
							else
								{
								// from sec3 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x1 - x2;
							dy = y2 - y1;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec3 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{
								// from sec3 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x1 - x2;
							dy = - ( y1 + y2 );
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec3 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{
								// from sec3 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							break;
						}
					}
				else
					{
					// sec4
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '1';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec4 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{
								// from sec4 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y2 - y1;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec4 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if ( y1 <= y2 )
									{
									// from sec4 to sec4
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{
									// from sec4 to sec4
									s = abs( Y1 - Y2 );
									}
								}
							dx = x1 - x2;
							dy = y2 - y1;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec4 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{
								// from sec4 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x1 - x2;
							dy = - ( y1 + y2 );
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec4 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{
								// from sec4 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							break;
						}
					}
				break;

			case 3:
				if ( x1 > y1 )
					{
					// sec5
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '1';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec5 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{
								// from sec5 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + 2 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec5 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec5 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;

						case 3:
							if ( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if ( y1 >= y2 )
									{
									// from sec5 to sec5
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{
									// from sec5 to sec5   y2 > y1
									s = abs( Y1 - Y2 );
									}
								}
							else
								{
								// from sec5 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec5 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + X2;
								}
							else
								{
								// from sec5 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
						}
					}
				else
					{
					// sec6
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '1';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec6 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{
								// from sec6 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec6 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec6 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec6 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 3 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if ( x1 <= x2 )
									{
									// from sec6 to sec6
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{
									// from sec6 to sec6
									s = X1 - X2;
									}
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec6 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{
								// from sec6 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
						}
					}
				break;

			case 4:
				if ( x1 < y1 )
					{
					// sec7
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '0';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec7 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{
								// from sec7 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec7 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{
								// from sec7 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec7 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}

							else
								{
								// from sec7 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  - ( x1 + x2 );
							dy = y1 - y2;
							break;

						case 4:
							if ( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if ( x1 >= x2 )
									{
									// from sec7 to sec7
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{
									// from sec7 to sec7
									s = X2 - X1;
									}
								}
							else
								{
								// from sec7 to sec8
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;
						}
					}
				else
					{
					//sec8
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '0';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 1:
							if ( x2 > y2 )
								{
								// from sec8 to sec1
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{
								// from sec8 to sec2
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;

						case 2:
							if ( x2 < y2 )
								{
								// from sec8 to sec3
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{
								// from sec8 to sec4
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;

						case 3:
							if ( x2 > y2 )
								{
								// from sec8 to sec5
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{
								// from sec8 to sec6
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = y1 - y2;
							break;

						case 4:
							if ( x2 < y2 )
								{
								// from sec8 to sec7
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if ( y1 <= y2 )
									{
									// from sec8 to sec8
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{
									// from sec8 to sec8
									s = abs( Y1 - Y2 );
									}
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;
						}
					}
			}

//-------------------------------------------------------------------

	else   // right around
		switch ( s1 )
			{
			case 4:
				if ( x1 > y1 )
					{
					// sec8
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '0';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if ( y1 >= y2 )
									{
									// from sec8 to sec8,   y1 >= y2,   long
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{
									// from sec8 to sec8,   y2 > y1,   short
									s = abs( Y1 - Y2 );
									}
								}
							else
								{
								// from sec8 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec8 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + X2;
								}
							else
								{
								// from sec8 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 - y2;
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec8 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{
								// from sec8 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec8 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec8 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + sy - Y2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
						}
					}
				else
					{
					// sec7
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '0';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec7 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 4 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if ( x1 <= x2 )
									{
									// from sec7 to sec7
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{
									// from sec7 to sec7   y2 > y1
									s = X1 - X2;
									}
								}
							dx = x2 - x1;
							dy = y1 - y2;
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec7 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{
								// from sec7 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								//KMessageBox::information ( 0, QString ( "sec7 - sec5 !\nx1 = %1\nx2 = %2" ).arg(x1).arg(x2) );
								}
							dx = - ( x1 + x2 );
							dy = y1 - y2;
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec7 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{
								// from sec7 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = y1 + y2;
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec7 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec7 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x2 - x1;
							dy = y1 + y2;
							break;
						}
					}
				break;

			case 3:
				if ( x1 < y1 )
					{
					// sec6
					kdev[2] = '1';
					kdev[3] = '1';
					kdev[4] = '1';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec6 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}

							else
								{
								// from sec6 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  x1 + x2;
							dy = y1 - y2;
							break;

						case 3:
							if ( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if ( x1 >= x2 )
									{
									// from sec6 to sec6
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{
									// from sec6 to sec6
									s = X2 - X1;
									}
								}
							else
								{
								// from sec6 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec6 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{
								// from sec6 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec6 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{
								// from sec6 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
						}
					}
				else
					{
					// sec5
					kdev[2] = '0';
					kdev[3] = '1';
					kdev[4] = '1';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec5 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{
								// from sec5 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec5 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if ( y1 <= y2 )
									{
									// from sec5 to sec5
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{
									// from sec5 to sec5
									s = abs( Y1 - Y2 );
									}
								}
							dx = x1 - x2;
							dy = y1 - y2;
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec5 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{
								// from sec5 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec5 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{
								// from sec5 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;
						}
					}
				break;

			case 2:
				if ( x1 > y1 )
					{
					// sec4
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '1';
					x1 = get_l1x( long( round( r * mf * 100.00 ) ), Y1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec4 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy + Y2;
								}
							else
								{
								// from sec4 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = - ( y1 + y2 );
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec4 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + 3 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec4 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 4 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = - ( y1 + y2 );
							break;

						case 2:   // s2 -> s2
							if ( x2 > y2 )
								{
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								if ( y1 >= y2 )
									{
									// from sec4 to sec4   y1 >= y2
									s = sy - Y1 + 4 * sx + 3 * sy + Y2;
									}
								else
									{
									// from sec4 to sec4   y2 > y1
									s = abs( Y1 - Y2 );
									}
								}
							else
								{
								// from sec4 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + sx - X2;
								}
							dx = x1 - x2;
							dy = y2 - y1;
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec4 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sy - Y1 + sx + sx - X2;
								}
							else
								{
								// from sec4 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sy - Y1 + 2 * sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y2 - y1;
							break;
						}
					}
				else
					{
					//sec3
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '1';
					y1 = get_l2y( long( round( r * mf * 100.00 ) ), X1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec3 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + sx + sy + Y2;
								}
							else
								{
								// from sec3 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + 2 * sy + sx - X2;
								}
							dx = x1 + x2;
							dy = y1 + y2;
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec3 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 + 2 * sx + 2 * sy + X2;
								}
							else
								{
								// from sec3 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 2 * sy + sy - Y2;
								}
							dx = x1 - x2;
							dy = y1 + y2;
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec3 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = X1 + 3 * sx + 4 * sy + Y2;
								}
							else
								{
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								if ( x1 <= x2 )
									{
									// from sec3 to sec3
									s = X1 + 3 * sx + 4 * sy + sx - X2;
									}
								else
									{
									// from sec3 to sec3
									s = X1 - X2;
									}
								}
							//KMessageBox::information ( 0, QString ( "/s2 - /s2 !" ) );
							dx = x1 - x2;
							dy = y2 - y1;
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec3 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = X1 +  X2;
								}
							else
								{
								// from sec3 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = X1 + sx + sy - Y2;
								}
							dx = x1 + x2;
							dy = y1 - y2;
							break;
						}
					}
				break;

			case 1:
				if ( x1 < y1 )
					{
					// sec2
					kdev[2] = '1';
					kdev[3] = '0';
					kdev[4] = '0';
					y1 = get_r2y( long( round( r * mf * 100.00 ) ), X1 ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec2 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + sy + Y2;
								}
							else
								{
								// from sec2 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx - X2;
								}
							dx = x2 - x1;
							dy = - ( y1 + y2 );
							//KMessageBox::information ( 0, QString ( "s1/ - s4 !" ) );
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec2 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + sx + X2;
								}
							else
								{
								// from sec2 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sy + 2 * sx + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = - ( y1 + y2 );
							//KMessageBox::information ( 0, QString ( "s1/ - s3 !" ) );
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec2 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 3 * sy + Y2;
								}

							else
								{
								// from sec2 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + 2 * sx + 4 * sy + sx - X2;
								}
							dx =  - ( x1 + x2 );
							dy = y2 - y1;
							//KMessageBox::information ( 0, QString ( "s1/ - s2 !" ) );
							break;

						case 1:
							if ( x2 < y2 )
								{
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								if ( x1 >= x2 )
									{
									// from sec2 to sec2
									s = sx - X1 + 3 * sx + 4 * sy + X2;
									}
								else
									{
									// from sec2 to sec2
									s = X2 - X1;
									}
								}
							else
								{
								// from sec2 to sec1
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = sx - X1 + sy - Y2;
								}
							dx = x2 - x1;
							dy = y2 - y1;
							//KMessageBox::information ( 0, QString ( "s1/ - s1 !" ) );
							break;
						}
					}
				else
					{
					//sec1
					kdev[2] = '0';
					kdev[3] = '0';
					kdev[4] = '0';
					x1 = get_r1x( long( round( r * mf * 100.00 ) ), Y1, sx, sy ) / ( mf * 100.00 );
					switch ( s2 )
						{
						case 4:
							if ( x2 > y2 )
								{
								// from sec1 to sec8
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + Y2;
								}
							else
								{
								// from sec1 to sec7
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + sy + sx - X2;
								}
							dx = x2 - x1;
							dy = - y1 - y2;
							//KMessageBox::information ( 0, QString ( "/s1 - s4 !" ) );
							break;

						case 3:
							if ( x2 < y2 )
								{
								// from sec1 to sec6
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + sy + sx + X2;
								}
							else
								{
								// from sec1 to sec5
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + sy + sy - Y2;
								}
							dx = - ( x1 + x2 );
							dy = - y1 - y2;
							//KMessageBox::information ( 0, QString ( "/s1 - s3 !" ) );
							break;

						case 2:
							if ( x2 > y2 )
								{
								// from sec1 to sec4
								x2 = get_l1x( long( round( r * mf * 100.00 ) ), Y2 ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 2 * sy + Y2;
								}
							else
								{
								// from sec1 to sec3
								y2 = get_l2y( long( round( r * mf * 100.00 ) ), X2, sx, sy ) / ( mf * 100.00 );
								s = Y1 + 2 * sx + 3 * sy + sx - X2;
								}
							dx = - ( x1 + x2 );
							dy = y2 - y1;
							//KMessageBox::information ( 0, QString ( "/s1 - s2 !" ) );
							break;

						case 1:
							if ( x2 < y2 )
								{
								// from sec1 to sec2
								y2 = get_r2y( long( round( r * mf * 100.00 ) ), X2 ) / ( mf * 100.00 );
								s = Y1 + 3 * sx + 3 * sy + X2;
								}
							else
								{
								x2 = get_r1x( long( round( r * mf * 100.00 ) ), Y2, sx, sy ) / ( mf * 100.00 );
								if ( y1 <= y2 )
									{
									// from sec1 to sec1
									s = Y1 + 4 * sx + 3 * sy + sy - Y2;
									}
								else
									{
									// from sec1 to sec1
									s = abs( Y1 - Y2 );
									}
								}
							dx = x2 - x1;
							dy = y2 - y1;
							//KMessageBox::information ( 0, QString ( "/s1 - s1 !" ) );
							break;
						}
					}
			}

	cd->steps = s;
	li = " kreisdev	";
	li += kdev;
	li += "\n praezision	" + QString::number( pr, 'f', 2 ) + "\n";
	if ( kdev[6] == '0' & kdev[7] == '0' )  // around Z
		{
		li += " x	" + QString::number( x1, 'f', 2 ) + "\n y	" + QString::number( y1, 'f', 2 ) + "\n radius	" + QString::number( r, 'f', 2 ) + "\n schritte	" + QString::number( s ) + "\n- dx=" + QString::number( dx, 'f', 3 ) + "  dy=" + QString::number( dy, 'f', 3 ) + "\n";
		cd->deltax = dx;
		cd->deltay = dy;
		cd->deltaz = 0;
		}
	else
		if ( kdev[6] == '0' & kdev[7] == '1' )  // around Y
			{
			li += " x	" + QString::number( x1, 'f', 2 ) + "\n z	" + QString::number( y1, 'f', 2 ) + "\n radius	" + QString::number( r, 'f', 2 ) + "\n schritte	" + QString::number( s ) + "\n- dx=" + QString::number( dx, 'f', 3 ) + "  dz=" + QString::number( dy, 'f', 3 ) + "\n";
			cd->deltax = dx;
			cd->deltay = 0;
			cd->deltaz = dy;
			}
		else
			if ( kdev[6] == '1' & kdev[7] == '0' )  // around X
				{
				li += " y	" + QString::number( x1, 'f', 2 ) + "\n z	" + QString::number( y1, 'f', 2 ) + "\n radius	" + QString::number( r, 'f', 2 ) + "\n schritte	" + QString::number( s ) + "\n- dy=" + QString::number( dx, 'f', 3 ) + "  dz=" + QString::number( dy, 'f', 3 ) + "\n";
				cd->deltax = 0;
				cd->deltay = dx;
				cd->deltaz = dy;
				}

	if ( pr > 0 )
		{
		cd->n = ( long( round( s / ( pr * 100 * mf ) ) ) );
		li += "- n=" + QString::number( cd->n ) + "\n";
		}
	else
		cd->n = 0;

	return li;
	}


