/***************************************************************************
 *   Copyright (C) 2005 by Sebastian Beck                                  *
 *   sebastian.bw@freenet.de                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "pcnc.h"
#include "pref.h"

#include <qdragobject.h>
#include <qpaintdevicemetrics.h>
#include <qfile.h>
#include <qevent.h>
#include <qtextedit.h>

#include <kprinter.h>
#include <kglobal.h>
#include <klocale.h>
#include <kiconloader.h>
#include <kdeversion.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <kkeydialog.h>
#include <kaccel.h>
#include <kio/netaccess.h>
#include <kfiledialog.h>
#include <kconfig.h>
#include <kurl.h>
#include <kurldrag.h>
#include <kurlrequesterdlg.h>
#include <kedittoolbar.h>
#include <kstdaccel.h>
#include <kaction.h>
#include <kstdaction.h>
#include <kcmdlineargs.h>
#include <kmessagebox.h>


PCNC::PCNC()
		: KMainWindow ( 0, "PCNC" )
	{
	// accept dnd
	setAcceptDrops ( true );

	// tell the KMainWindow that this is indeed the main widget
	PCNCView *CW = new PCNCView ( this );
	setCentralWidget ( CW );

	// then, setup our actions
	setupActions();

	// and a status bar
	statusBar()->show();


	// apply the saved mainwindow settings, if any, and ask the mainwindow
	// to automatically save settings if changed: window size, toolbar
	// position, icon size, etc.
	setAutoSaveSettings();

	// allow the view to change the statusbar and caption
	connect ( CW, SIGNAL ( signalChangeStatusbar ( const QString& ) ), this, SLOT ( changeStatusbar ( const QString& ) ) );
	//connect( this, SIGNAL( close() ), this->centralWidget(), SLOT( quit() ) );

//    connect( anzeige, SIGNAL(signalChangeCaption(const QString&)), this, SLOT(changeCaption(const QString&)));


// 	KMessageBox::information( 0, QString("Die Datei hei�: %1 ?").arg( arg.pathOrURL() ), "Achtung");
// 	anzeige.nc_datei = arg.pathOrURL();
	}

PCNC::~PCNC()
	{
	}

void PCNC:: closeEvent ( QCloseEvent *ce )
	{
	CW->quit_pcnc( ce );
	}

void PCNC::setupActions()
	{
	KStdAction::openNew ( this->centralWidget(), SLOT ( fileNew() ), actionCollection() );
	KStdAction::open ( this->centralWidget(), SLOT ( read() ), actionCollection() );
	KStdAction::save ( this->centralWidget(), SLOT ( write() ), actionCollection() );
	KStdAction::saveAs ( this->centralWidget(), SLOT ( writeto( ) ), actionCollection() );
	KStdAction::print ( this, SLOT ( filePrint() ), actionCollection() );
	KStdAction::quit ( kapp, SLOT ( quit() ), actionCollection() );

	KMainWindow::setStandardToolBarMenuEnabled ( TRUE );
	m_statusbarAction = KStdAction::showStatusbar ( this, SLOT ( optionsShowStatusbar() ), actionCollection() );

	KStdAction::keyBindings ( this, SLOT ( optionsConfigureKeys() ), actionCollection() );
	KStdAction::configureToolbars ( this, SLOT ( optionsConfigureToolbars() ), actionCollection() );
	KStdAction::preferences ( this, SLOT ( optionsPreferences() ), actionCollection() );

	new KAction ( i18n ( "&Ausfuehren" ), 0, this->centralWidget(), SLOT ( make_nc() ), actionCollection(), "Start_action" );
	new KAction ( "Wrekzeuge", 0, this->centralWidget(), SLOT ( werkzeuge() ), actionCollection(), "Werkzeug_action" );
	new KAction ( "Fraesmaschinen", 0, this->centralWidget(), SLOT ( maschiene() ), actionCollection(), "Maschinen_action" );

	createGUI();
	}

void PCNC::saveProperties ( KConfig *config )
	{
	// the 'config' object points to the session managed
	// config file.  anything you write here will be available
	// later when this app is restored

//     if (!m_view->currentURL().isEmpty()) {
// #if KDE_IS_VERSION(3,1,3)
//         config->writePathEntry("lastURL", m_view->currentURL());
// #else
//         config->writeEntry("lastURL", m_view->currentURL());
// #endif
//     }
	}

void PCNC::readProperties ( KConfig *config )
	{
	// the 'config' object points to the session managed
	// config file.  this function is automatically called whenever
	// the app is being restored.  read in here whatever you wrote
	// in 'saveProperties'

	QString url = config->readPathEntry ( "lastURL" );

// 	if (!url.isEmpty())
// 		{
// 		}

	}

// void PCNC::load(const KURL u1)
// 	{
// 	arg = u1;
// 	}



void PCNC::dragEnterEvent ( QDragEnterEvent *event )
	{
	// accept uri drops only
	event->accept ( KURLDrag::canDecode ( event ) );
	}

void PCNC::dropEvent ( QDropEvent *event )
	{
	// this is a very simplistic implementation of a drop event.  we
	// will only accept a dropped URL.  the Qt dnd code can do *much*
	// much more, so please read the docs there
//     KURL::List urls;
//
//     // see if we can decode a URI.. if not, just ignore it
//     if (KURLDrag::decode(event, urls) && !urls.isEmpty())
//     {
//         // okay, we have a URI.. process it
//         const KURL &url = urls.first();

	// load in the file
//         load(url);
//     }
	}


void PCNC::filePrint()
	{
	// this slot is called whenever the File->Print menu is selected,
	// the Print shortcut is pressed (usually CTRL+P) or the Print toolbar
	// button is clicked
//     if (!m_printer) m_printer = new KPrinter;
//     if (m_printer->setup(this))
//     {
//         // setup the printer.  with Qt, you always "print" to a
//         // QPainter.. whether the output medium is a pixmap, a screen,
//         // or paper
//         QPainter p;
//         p.begin(m_printer);
//
//         // we let our view do the actual printing
// //         QPaintDeviceMetrics metrics(m_printer);
// //         m_view->print(&p, metrics.height(), metrics.width());
//
//         // and send the result to the printer
// //         p.end();
//     }
	}

void PCNC::optionsShowToolbar()
	{
	// this is all very cut and paste code for showing/hiding the
	// toolbar
	if ( m_toolbarAction->isChecked() )
		toolBar()->show();
	else
		toolBar()->hide();
	}

void PCNC::optionsShowStatusbar()
	{
	// this is all very cut and paste code for showing/hiding the
	// statusbar
	if ( m_statusbarAction->isChecked() )
		statusBar()->show();
	else
		statusBar()->hide();
	}

void PCNC::changeStatusbar ( const QString& text )
	{
	statusBar()->message ( text );
	}


void PCNC::optionsConfigureKeys()
	{
	KKeyDialog::configure ( actionCollection() );
	}

void PCNC::optionsConfigureToolbars()
	{
	// use the standard toolbar editor
#if defined(KDE_MAKE_VERSION)
# if KDE_VERSION >= KDE_MAKE_VERSION(3,1,0)
	saveMainWindowSettings ( KGlobal::config(), autoSaveGroup() );
# else
	saveMainWindowSettings ( KGlobal::config() );
# endif
#else
	saveMainWindowSettings ( KGlobal::config() );
#endif
	}

void PCNC::newToolbarConfig()
	{
	// this slot is called when user clicks "Ok" or "Apply" in the toolbar editor.
	// recreate our GUI, and re-apply the settings (e.g. "text under icons", etc.)
	createGUI();

#if defined(KDE_MAKE_VERSION)
# if KDE_VERSION >= KDE_MAKE_VERSION(3,1,0)
	applyMainWindowSettings ( KGlobal::config(), autoSaveGroup() );
# else
	applyMainWindowSettings ( KGlobal::config() );
# endif
#else
	applyMainWindowSettings ( KGlobal::config() );
#endif
	}

void PCNC::optionsPreferences()
	{
	// popup some sort of preference dialog, here
	PCNCPreferences dlg;
	if ( dlg.exec() )
		{
		// redo your settings
		}
	}


#include "pcnc.moc"
